#define ZASM_FUNCTIONS_C 1

#include <zasm/functions.h>

int function_ifthenelse(int a, int b, int c){return a?b:c;}

int function_log_or (int a, int b, int c){return a||b;}
int function_log_and(int a, int b, int c){return a&&b;}
int function_log_not(int a, int b, int c){return !a;}
int function_log_xor(int a, int b, int c){return (a||b)&&(!(a&&b));}
int function_bit_or (int a, int b, int c){return a|b;}
int function_bit_and(int a, int b, int c){return a&b;}
int function_bit_not(int a, int b, int c){return ~a;}
int function_bit_xor(int a, int b, int c){return a^b;}

int function_shift_left (int a, int b, int c){return a<<b;}
int function_shift_right(int a, int b, int c){return a>>b;}

int function_equ(int a, int b, int c){return a==b;}
int function_neq(int a, int b, int c){return a!=b;}
int function_lt(int a, int b, int c){return a<b;}
int function_gt(int a, int b, int c){return a>b;}
int function_le(int a, int b, int c){return a<=b;}
int function_ge(int a, int b, int c){return a>=b;}
int function_cmp(int a, int b, int c){return (a>=b) - (a<=b);}

int function_add(int a, int b, int c){return a+b;}
int function_sub(int a, int b, int c){return a-b;}
int function_neg(int a, int b, int c){return -a;}
int function_mul(int a, int b, int c){return a*b;}
int function_div(int a, int b, int c){return a/b;}
int function_mod(int a, int b, int c){return a%b;}
int function_pow(int a, int b, int c)
{
  int v, t;
  for (v=1, t=a; b > 0; b>>=1, t=t*t)
    {
      if (b&1)
        v = v*t;
    }
  return v;
}
