#ifndef ZASM_FUNCTIONS_H
#define ZASM_FUNCTIONS_H 1

// functions used for operators
int function_ifthenelse(int a, int b, int c); // ? :

int function_log_or (int a, int b, int c); // ||
int function_log_and(int a, int b, int c); // &&
int function_log_not(int a, int b, int c); // !! // ! // ~~
int function_log_xor(int a, int b, int c); // ^^
int function_bit_or (int a, int b, int c); // .| // |
int function_bit_and(int a, int b, int c); // .& // &
int function_bit_not(int a, int b, int c); // .! // .~ // ~
int function_bit_xor(int a, int b, int c); // .^ // ^

int function_shift_left (int a, int b, int c); // << // .<
int function_shift_right(int a, int b, int c); // >> // .>

int function_equ(int a, int b, int c); // ==
int function_neq(int a, int b, int c); // != // /= // <>
int function_lt(int a, int b, int c); // <
int function_gt(int a, int b, int c); // >
int function_le(int a, int b, int c); // <= // =<
int function_ge(int a, int b, int c); // >= // =>
int function_cmp(int a, int b, int c); // <=> // >=<

int function_add(int a, int b, int c); // +
int function_sub(int a, int b, int c); // -
int function_neg(int a, int b, int c); // unary -
int function_mul(int a, int b, int c); // *
int function_div(int a, int b, int c); // /
int function_mod(int a, int b, int c); // %
int function_pow(int a, int b, int c); // **

#endif
